%{
	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>

	int maxAlunos = 0;
	char escolaMaxAlunos[50], erro[256];

void verificaAlunos(char *nomeEscola, int nAlunos);
void setMaxAlunos(char *nomeEscola, int nAlunos);

%}

%union{
	int inteiro;
	char * string;
}

%token ENG_INFORMATICA
%token <string> ISEP OUTRA_ESCOLA STRING
%token <inteiro> INT

%%

escolas:	/* vazio */
	|	escolas escola
	;

escola:	ISEP INT STRING '\n' 	professores_isep	{ verificaAlunos($1,$2); setMaxAlunos($1,$2); free($1); }
	|	OUTRA_ESCOLA INT STRING '\n' professores { verificaAlunos($1, $2); setMaxAlunos($1,$2); free($1); }
	;

professores_isep:	professores_isep professor_isep
				| professor_isep
				;

professor_isep:	STRING INT STRING '\n' {  if (verificaExtensao($1,$2)==0) printf("Professor %s tem a extensao %d\n", $1, $2); }
			;

professores:	professores professor
			| professor
				;

professor:	STRING INT STRING '\n'  { verificaExtensao($1,$2); }
			;



%%

int main(){
	yyparse();

	printf("A escola com mais alunos e %s com %d alunos!\n", escolaMaxAlunos, maxAlunos);
	
	return EXIT_SUCCESS;
}

void verificaAlunos(char *nomeEscola, int nAlunos) {

	if (nAlunos<101) {
		strcpy(erro,"Numero de alunos de ");
		strcat(erro, nomeEscola);
		strcat(erro, " deve ser maior que 100");

		yyerror(erro);
	}
}

int verificaExtensao(char *nomeProfessor, int extensao) {
	if (extensao<1000) {
		strcpy(erro,"Extensao do docente ");
		strcat(erro, nomeProfessor);
		strcat(erro, " deve ser maior que 999");

		yyerror(erro);
		return 1;
	}
	return 0;
}


void setMaxAlunos(char *nomeEscola, int nAlunos) {
	if (nAlunos>maxAlunos) {
		maxAlunos=nAlunos;
		strcpy(escolaMaxAlunos, nomeEscola);
	}
}

int yyerror(char *s){
	printf("Erro: %s\n", s);
	return 0;
}

